searchData={"content_type":"text/markdown","items":[{"doc":"Enable searching a directory for nested set of dependencies.\n\nThese are free form and coverted to a local path instead of using\nhex, git or similar to fetch it. The monorepo may optionally export\nall dependencies to archives using the command `mix monorepo.export`.","ref":"ExMonorepo.html","title":"ExMonorepo","type":"module"},{"doc":"defmodule TestProject.MixProject do\n    use Mix.Project\n    use ExMonorepo\n  end","ref":"ExMonorepo.html#module-example","title":"Example - ExMonorepo","type":"module"},{"doc":"A monorepo should have the file repo.exs to define it's configuration (if any).\nthe content is a set of variables like `root`, `dist` which will be set in\nthe project options.","ref":"ExMonorepo.html#module-detecting-monorepo","title":"Detecting monorepo - ExMonorepo","type":"module"},{"doc":"If `dist` option is used all the non-monorepo dependencies\nare exported to a `.ez` file tagged with app, version and checksum.\nWhen starting a mix command all the archives are added to path and\nmay be used without recompiling.\n\nIf the archive is deleted the dependency will revert to normal\ndependency handling.","ref":"ExMonorepo.html#module-using-archives","title":"Using archives - ExMonorepo","type":"module"},{"doc":"Expand common options\n\nTakes some variables supporting relative path and expands them according\nto the directory (typically the dirname of monorepo.exs)","ref":"ExMonorepo.html#map_config_item/2","title":"ExMonorepo.map_config_item/2","type":"function"},{"doc":"Extract values from a repofile","ref":"ExMonorepo.html#parse_repofile/1","title":"ExMonorepo.parse_repofile/1","type":"function"},{"doc":"Get all possible repofiles from `path` to filesystem root (`/`)","ref":"ExMonorepo.html#repofiles/1","title":"ExMonorepo.repofiles/1","type":"function"},{"doc":"Shows the known changes that should lead to recompilation of a application.\n\nA change is detected by looking at `elixirc_paths` in each project,\nfinding all elixir files matching and then lstating them.\nThe results is compared to the values in `./.mix/monorepo.changes` (for each build).\nIf any of the files changed then it's shown.\n\nThe manifests for each compiler in the project can help in giving a\ndependency graph which can be used to decide which deps and apps needs\nrecompilation.","ref":"Mix.Tasks.Monorepo.Changes.html","title":"mix monorepo.changes","type":"task"},{"doc":"Retrieve a keyword list of applications in monorepo with changes.","ref":"Mix.Tasks.Monorepo.Changes.html#scan_for_changes/1","title":"Mix.Tasks.Monorepo.Changes.scan_for_changes/1","type":"function"},{"doc":"Detects the changes in a monorepo and attempts to compile them all.\n\n    $ mix monorepo.compile [repo path]\n\nOnly dependencies of the root project will be compile using this method,\nthe root project will not be comiled as it's not a dependency.","ref":"Mix.Tasks.Monorepo.Compile.html","title":"mix monorepo.compile","type":"task"},{"doc":"Takes all the dependenceis of the project and exports as a .ez files.\n\n    $ mix monorepo.export\n\nThe export is always done for a combination of lockfile, arch, erlang/elixir\nvsns such that for every update in dependencies, versions or similar the\narchives must be rexported\n\nOnly dependencies from hex are exported.","ref":"Mix.Tasks.Monorepo.Export.html","title":"mix monorepo.export","type":"task"},{"doc":"Get the source checksum of from a lock","ref":"Mix.Tasks.Monorepo.Export.html#lock_meta/2","title":"Mix.Tasks.Monorepo.Export.lock_meta/2","type":"function"},{"doc":"Get runtime target","ref":"Mix.Tasks.Monorepo.Export.html#target/0","title":"Mix.Tasks.Monorepo.Export.target/0","type":"function"},{"doc":"# ExMonorepo\n\nAdd minimal support for storing apps as a unstructured monorepo.","ref":"readme.html","title":"ExMonorepo","type":"extras"},{"doc":"```\n$ git clone git://gitlab.com/fwtno/exmonorepo\n$ cd exmonorepo && mix archive.build && mix archive.install exmonorepo*.ez\n```\n\nTo use it make a file `monorepo.exs` with the contents `repo = \"./\"` and set `use ExMonorepo` in `mix.exs`.\n\n```elixir\ndefmodule ExpkgTest.MixProject do\n  use Mix.Project\n\n  # Use monorepo implementation\n  use ExMonorepo\n\n  def project do\n    [\n      app: :expkg,\n      version: \"0.1.0\",\n      elixir: \"~> 1.13\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n    ]\n  end\n\n  def application do\n    [extra_applications: [:logger]]\n  end\n\n  defp deps do\n    [{:dependency, \"~> 0.1\"}, {:root, \"~> 0.1\"}]\n  end\nend\n```","ref":"readme.html#installation","title":"Installation - ExMonorepo","type":"extras"},{"doc":"* Only supports mix dependencies - not rebar/make/...\n * Umbrella apps are not tested - may behave weird\n * Consider this as alpha software, paper cuts and chopped limbs will occur.\n * Keeping `__DIR__` as monorepo will have weird side effects.\n * This is a gready SCM, it will disable fetching from hex (and possibly others)\n   in case it find the dependency. It's important to keep `deps/` folder\n   out of search path.","ref":"readme.html#known-limitations","title":"Known Limitations - ExMonorepo","type":"extras"},{"doc":"Copyright (C) FWT AS\n\nRedistribution and use in source and binary forms, with or without modification,\nare permitted provided that the following conditions are met:\n\n1. Redistributions of source code must retain the above copyright notice, this\n  list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright notice,\n  this list of conditions and the following disclaimer in the documentation\n  and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its contributors\n  may be used to endorse or promote products derived from this software\n  without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\"\nAND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE\nIMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE\nARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE\nLIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR\nCONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF\nSUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS\nINTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN\nCONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)\nARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE\nPOSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Generalize configuration through `monorepo.exs`, adds task `monorepo.changes`\nand `monorepo.compile`. \n\nNew monorepos should use `repo = \"./repo\"` in `monorepo.exs` at root level to\nestablish repository configuration. For now `monorepo.compile` can be used\nfor a only compiling changed applications in the repo but regular `compile`\nshould work fine.\n\nThere's no significant testing done at this point but two moderately complex\numbrella projects have been converted without any difficulties.","ref":"changelog.html#exmonorepo-0-2-1-2023-09-17","title":"exmonorepo-0.2.1 (2023-09-17) - Changelog","type":"extras"},{"doc":"Moves monorepo functions into own file and add function to export all dependency as archives.","ref":"changelog.html#exmonorepo-0-2-0-2023-09-06","title":"exmonorepo-0.2.0 (2023-09-06) - Changelog","type":"extras"},{"doc":"# Converting Umbrella Project\n\nUmbrella projects dependencies are marked with `in_umbrella` and share a common\nconfiguration (like `build_path`, `deps_path`, ...) in `mix.exs`. \n\nOne of the pain points with umbrella projects is that compilation is ran for\neach app irregardless of any changes having occurred. If there are slow compilation\ntasks or there are many applications compilation will start to take a significant\namount of time. With short iterations and frequent compilation this may become\na annoyance, or expensive in case of CI pipelines.\n\nTo convert a umbrella project can be done with a simple switch:\n\n```elixir\ndefmodule UmbrellaProject.MixProject do\n  use Mix.Project\n\n  def project do\n    [\n      apps_path: \"apps\",\n      version: \"0.1.0\",\n      start_permanent: Mix.env() == :prod,\n      deps: deps(),\n      aliases: aliases(),\n      releases: releases(),\n      elixirc_options: [\n        warnings_as_errors: true\n      ]\n    ]\n  end\n\n  # removed for brievety\nend\n```\n\nFirst is to add `ExMonorepo` to the project, remove `apps_path` and add a `app` key.\nThis will make one application with the umbrella apps as dependencies.\n\n```diff\n@@ -1,9 +1,9 @@\n defmodule Umbrella.MixProject do\n   use Mix.Project\n+  use ExMonorepo\n \n   def project do\n     [\n-      apps_path: \"apps\",\n+      app: :umbrella_parent,\n       version: \"0.1.0\",\n       start_permanent: Mix.env() == :prod,\n       deps: deps(),\n```\nThen make a new file `monorepo.exs` and set the `repo` variable:\n\n```sh\necho 'repo = \"./apps\"' > monorepo.exs\n```\n\nRunning `mix deps.tree` will most likely be empty, add a app as dependencies:\n\n```diff\nuser@nyx:~/src/fwt/exmonorepo/tnest-edge$ g diff mix.exs \ndiff --git a/mix.exs b/mix.exs\nindex 8201047c..5bd2cde0 100644\n--- a/mix.exs\n+++ b/mix.exs\n@@ -60,7 +61,8 @@ defmodule Umbrella.MixProject do\n       {:credo, \"~> 1.5\", only: [:dev, :test], runtime: false},\n       {:junit_formatter, \"~> 3.3\", only: [:test]},\n       {:dialyzex, \"~> 1.2.0\", only: :dev},\n+      {:umbrella_web, \"~> 0.1\"},\n     ]\n   end\n```\n\nRunning `mix deps.tree` should now show a longer list:\n\n```sh\n$ mix deps.tree\numbrella_parent\n├── dialyzex ~> 1.2.0 (Hex package)\n├── dispatchex ~> 0.1 (Hex package)\n├── junit_formatter ~> 3.3 (Hex package)\n├── umbrella ~> 0.1 (repo: umbrella)\n├── umbrella_web ~> 0.1 (repo: umbrella_web)\n│   ├── esbuild ~> 0.4 (Hex package)\n│   │   └── castore >= 0.0.0 (Hex package)\n│   ├── ex_cldr_dates_times ~> 2.12 (Hex package)\n│   │   └── ...\n│   ├── gettext ~> 0.18 (Hex package)\n│   │   └── expo ~> 0.4.0 (Hex package)\n│   ├── jason ~> 1.0 (Hex package)\n│   ├── phoenix ~> 1.7.0 (Hex package) *override*\n│   │   └── ...\n│   ├── tailwind ~> 0.1 (Hex package)\n│   │   └── castore >= 0.0.0 (Hex package)\n└── toml ~> 0.6.1 (Hex package)\n```\n\nThis detects all the apps and should compile and work out of the box. You might\nneed to delete `_build` or `deps`. Depending on the structure of your application\nyou may need to add them in `deps/0` in the project.\n\n#","ref":"converting-umbrella-project.html","title":"Converting Umbrella Project","type":"extras"},{"doc":"Testing recompilation time of converted umbrella project with 10 apps gives the same recompilation time as the original umbrella. It's assumed this is due to each app\nbeing recompiled in sequence. There's no significant improvement as of `exmonorepo-v0.2.1`.\nFor scenarios it may be faster if it's naive approach to change detection avoids\nrecompiling several apps.","ref":"converting-umbrella-project.html#performance","title":"Performance - Converting Umbrella Project","type":"extras"}]}